jQuery(document).ready(function ($) {

    $('#mainwp_blogvault_install').live('click', function () {
        blogvault_install_bulk();
        return false;
    });

    $("#mainwp_blogvault_show_installed_sites").live('click', function () {
        var show = $(this).attr('show');
        if (show == 'all') {
            $(this).attr('show', 'previous');
            $(this).text(__('Show Child Sites From Previous Installation'));
            $('#mwp_blogvault_previous_installed_sites').hide();
            $('#mwp_blogvault_all_installed_sites').fadeIn(500);
        } else {
            $(this).attr('show', 'all');
            $(this).text(__('Show All Child Sites'));
            $('#mwp_blogvault_previous_installed_sites').fadeIn(500);
            $('#mwp_blogvault_all_installed_sites').hide();
        }
        return false;
    });

    blogvault_install_bulk = function () {
        var data = {
            action: 'blogvault_prepareinstallplugin',
            type: 'plugin',
            slug: 'blogvault-real-time-backup',
            selected_by: jQuery('#select_by').val()
        };

        if (jQuery('#select_by').val() == 'site') {
            var selected_sites = [];
            jQuery("input[name='selected_sites[]']:checked").each(function (i) {
                selected_sites.push(jQuery(this).val());
            });

            if (selected_sites.length == 0) {
                show_error('ajax-error-zone', __('Please select websites or groups on the right side to install files.'));
                return;
            }
            data['selected_sites[]'] = selected_sites;
        } else {
            var selected_groups = [];
            jQuery("input[name='selected_groups[]']:checked").each(function (i) {
                selected_groups.push(jQuery(this).val());
            });
            if (selected_groups.length == 0) {
                show_error('ajax-error-zone', __('Please select websites or groups on the right side to install files.'))
                return;
            }
            data['selected_groups[]'] = selected_groups;
        }

        jQuery.post(ajaxurl, data, function () {
            return function (response) {
                var installQueue = '<h3>Installing plugin</h3>';
                for (var siteId in response.sites) {
                    var site = response.sites[siteId];
                    var site_name = site['name'].replace(/\\(.)/mg, "$1");
                    installQueue += '<span class="siteBulkInstall" siteid="' + siteId + '" status="queue"><strong>' + site_name + '</strong>: <span class="queue">' + __('Queued') + '</span><span class="progress"><i class="fa fa-spinner fa-pulse"></i> ' + __('In progress') + '</span><span class="status"></span></span><br />';
                    blogvault_bulkInstallTotal++;
                }

                jQuery('#mwp_blogvault_install_box').html(installQueue);
                blogvault_install_bulk_start_next(response.url);
            }
        }(), 'json');
        jQuery('#mwp_blogvault_install_box').html('<br /><i class="fa fa-spinner fa-pulse"></i> ' + __('Preparing plugin installation.'));
    };

    blogvault_bulkInstallMaxThreads = 3;
    blogvault_bulkInstallCurrentThreads = 0;
    blogvault_bulkInstallTotal = 0;
    blogvault_bulkInstallFinished = 0;
    blogvault_successedSiteIds = [];

    blogvault_install_bulk_start_next = function (pUrl) {
        while ((siteToInstall = jQuery('.siteBulkInstall[status="queue"]:first')) && (siteToInstall.length > 0) && (blogvault_bulkInstallCurrentThreads < blogvault_bulkInstallMaxThreads)) {
            blogvault_install_bulk_start_specific(pUrl, siteToInstall);
        }
        if (blogvault_bulkInstallFinished == blogvault_bulkInstallTotal) {
            var data = mainwp_secure_data({
                action: 'blogvault_finishedinstallplugin',
                'siteids[]': blogvault_successedSiteIds,
            });
            jQuery.post(ajaxurl, data, function (reponse) {
                window.location = 'admin.php?page=Extensions-Mainwp-Blogvault-Backup-Extension';
            });
        }
    };

    blogvault_install_bulk_start_specific = function (pUrl, pSiteToInstall) {
        blogvault_bulkInstallCurrentThreads++;
        pSiteToInstall.attr('status', 'progress');
        pSiteToInstall.find('.queue').hide();
        pSiteToInstall.find('.progress').show();
        var data = mainwp_secure_data({
            action: 'blogvault_performinstallplugin',
            type: 'plugin',
            url: pUrl,
            siteId: pSiteToInstall.attr('siteid'),
            activatePlugin: 'true',
            overwrite: 'true',
        });

        jQuery.post(ajaxurl, data, function (pUrl, pSiteToInstall) {
            return function (response) {
                pSiteToInstall.attr('status', 'done');

                pSiteToInstall.find('.progress').hide();
                var statusEl = pSiteToInstall.find('.status');
                statusEl.show();

                if ((response.ok != undefined) && (response.ok[pSiteToInstall.attr('siteid')] != undefined)) {
                    statusEl.html(__('Installation successful'));
                    blogvault_successedSiteIds.push(pSiteToInstall.attr('siteid'));
                } else if ((response.errors != undefined) && (response.errors[pSiteToInstall.attr('siteid')] != undefined)) {
                    statusEl.html(__('Installation failed') + ': ' + response.errors[pSiteToInstall.attr('siteid')][1]);
                    statusEl.css('color', 'red');
                } else {
                    statusEl.html(__('Installation failed'));
                    statusEl.css('color', 'red');
                }

                blogvault_bulkInstallCurrentThreads--;
                blogvault_bulkInstallFinished++
                blogvault_install_bulk_start_next(pUrl);
            }
        }(pUrl, pSiteToInstall), 'json');
    };
});


jQuery(document).ready(function ($) {
    jQuery('.mainwp-show-tut').on('click', function () {
        jQuery('.mainwp-blv-tut').hide();
        var num = jQuery(this).attr('number');
        jQuery('.mainwp-blv-tut[number="' + num + '"]').show();
        mainwp_setCookie('blogvault_quick_tut_number', jQuery(this).attr('number'));
        return false;
    });

    jQuery('#mainwp-blogvault-quick-start-guide').on('click', function () {
        if (mainwp_getCookie('blogvault_quick_guide') == 'on') {
            mainwp_setCookie('blogvault_quick_guide', '');
        } else {
            mainwp_setCookie('blogvault_quick_guide', 'on');
        }
        blogvault_showhide_quick_guide();
        return false;
    });
    jQuery('#mainwp-blogvault-tips-dismiss').on('click', function () {
        mainwp_setCookie('blogvault_quick_guide', '');
        blogvault_showhide_quick_guide();
        return false;
    });

    blogvault_showhide_quick_guide();

});

blogvault_showhide_quick_guide = function () {
    var show = mainwp_getCookie('blogvault_quick_guide');
    if (show == 'on') {
        jQuery('#mainwp-blv-tips').show();
        jQuery('#mainwp-blogvault-quick-start-guide').hide();
        blogvault_showhide_quick_tut();
    } else {
        jQuery('#mainwp-blv-tips').hide();
        jQuery('#mainwp-blogvault-quick-start-guide').show();
    }

}

blogvault_showhide_quick_tut = function () {
    var tut = mainwp_getCookie('blogvault_quick_tut_number');
    jQuery('.mainwp-blv-tut').hide();
    jQuery('.mainwp-blv-tut[number="' + tut + '"]').show();
}

